
#ifndef _UTILITY_H
#define _UTILITY_H
#ifndef _SYS_TYPES_H
#include <sys/types.h>
#endif
struct LISTHEAD {
struct LISTHEAD *Next;
struct LISTHEAD *Prev;
};
struct LISTCONTROL {
struct LISTHEAD *Head;
struct LISTHEAD *Tail;
unsigned Size;
};
struct PROMPTHEAD {
short width;
short height;
colour_t paper;
colour_t ink;
};
struct PROMPTLINE {
short xpos;
short ypos;
char *text;
};
struct PROMPTSET {
struct PROMPTHEAD head;
struct PROMPTLINE line[2];
};
struct VARLINE {
short xpos;
short ypos;
short type;
union {
void *dummy;
char *Text;
int *Int;
long *Long;
short *Word;
unsigned char *Byte;
} where;
short maxlength;
int (*validate)();
};
struct VARSET {
struct PROMPTHEAD head;
struct VARLINE line[2];
};
struct MENULINE {
short active;
char *text;
};
struct MENUSET {
struct PROMPTHEAD head;
short xpos;
short ypos;
char Vertical;
char InitOpt;
struct MENULINE line[1];
};
typedef union {
char str[8];
long num[2];
} ENCRYPTED;
extern ENCRYPTED SerialNumber;
extern char Encrypt_Private_Key[8];
extern char RegisteredUser[4 * sizeof(ENCRYPTED)];
#ifndef ENCRYPT_PRIVATE_KEY
#define ENCRYPT_PRIVATE_KEY"\xF0\x0F\x10\x01\x70\x07\x3A"
#endif
#ifndef _STDIO_H
#include <stdio.h>
#endif
#ifdef __STDC__
#define _P_(params) params
#else
#define _P_(params) ()
#endif
int Answer_QANY _P_((FILE *));
int Answer_YN _P_((FILE *));
void Byte_Reverse_2 _P_((void *));
void Byte_Reverse_3 _P_((void *));
void Byte_Reverse_4 _P_((void *));
void Centre _P_((FILE *,int,char *));
int CharHeight _P_((int));
int CharWidth _P_((int));
void Decrypt _P_((void *));
void Encrypt _P_((void *));
int Legal_Encrypt _P_((void * pEncrypt));
int EditInteger _P_((FILE *,int *));
int EditString _P_((FILE *,char *,int));
int fGetKey _P_((FILE *));
int FromOctal _P_((void *,int));
int GetKey _P_((void));
long Get_Byte_Reversed _P_((void *,int));
char *Get_Memory _P_((long));
int GetVariables _P_((FILE *,struct VARSET *));
short Intel _P_((void *));
long Intel_3 _P_((void *));
long Intel_L _P_((void *));
void List_Release_All _P_((struct LISTCONTROL *));
int List2_Add_End _P_((struct LISTCONTROL *));
void List2_Release_End _P_((struct LISTCONTROL *));
void Make_Byte_Reversed _P_((long,void *,int));
char *MakeVariable _P_((struct VARLINE *));
int Menu _P_((FILE *,struct MENUSET *));
void PromptLine _P_((FILE *,short,short,char *));
int Put_Memory _P_((void *));
void ShowPrompts _P_((FILE *,struct PROMPTSET *));
void ShowString _P_((FILE *,char *));
void ShowVariables _P_((FILE *,struct VARSET *));
void Store_Intel _P_((short,void *));
void Store_Intel_3 _P_((long,void *));
void Store_Intel_L _P_((long,void *));
char *StripSpaces _P_((char *));
void ToOctal _P_((int,void *,int));
extern FILE *StdTitle;
extern FILE *StdInfo;
extern FILE *StdError;
extern int StdFile,
TitleFile,
ErrorFile,
InfoFile;
extern long StdChan,
QramChan,
TitleChan,
ErrorChan,
InfoChan;
void Clear_All_Windows _P_((void));
void Initialise_Windows _P_((void));
void Reset_Windows _P_((void));
void Show_Title _P_((void));
void Action_Title _P_((char *));
void At_Stdout _P_((short,short));
void At_Stderr _P_((short,short));
void Clear_Stdout _P_((void));
void Clear_Stderr _P_((void));
void Clear_StdInfo _P_((void));
void Clear_StdTitle _P_((void));
void Csize_Stdout _P_((short,short));
void Csize_Stderr _P_((short,short));
void Csize_StdInfo _P_((short,short));
void Ink_Csize_Stdout _P_((colour_t,short,short));
void Ink_Csize_Stderr _P_((colour_t,short,short));
void Ink_Csize_StdInfo _P_((colour_t,short,short));
void Ink_Stdout _P_((colour_t));
void Ink_Stderr _P_((colour_t));
void Ink_StdInfo _P_((colour_t));
void Ink_StdTitle _P_((colour_t));
void Paper_Ink_Stdout _P_((colour_t,colour_t));
void Paper_Ink_StdInfo _P_((colour_t,colour_t));
void Paper_Stdout _P_((colour_t));
void Paper_StdInfo _P_((colour_t));
void Strip_Stdout _P_((colour_t));
void Strip_StdInfo _P_((colour_t));
#endif
